/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 228 by dpavlin, Sat Sep 11 11:51:37 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
38    
39  rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  lxc_rootfs() {
40  echo "$name rootfs $rootfs"          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    
44    lxc_status() {
45            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                    boot="-"
47                    hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                    ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49                    test -z "$ip" && ip=`grep lxc.network.ipv4 /var/lib/lxc/narada/config | cut -d= -f2`
50                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
51                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
52            done ) | column -t
53    }
54    
55    
56    cleanup_init_scripts() {
57            rootfs=$(lxc_rootfs $1)
58    
59            ls \
60                    $rootfs/etc/rc?.d/*umountfs \
61                    $rootfs/etc/rc?.d/*umountroot \
62                    $rootfs/etc/rc?.d/*hwclock* \
63                    $rootfs/etc/rc?.d/*udev* \
64            2>/dev/null | xargs -i rm -v {}
65    
66            echo $1 > $rootfs/etc/hostname
67    }
68    
69    
70    setup_inittab() {
71            rootfs=$(lxc_rootfs $1)
72            remove=$2
73            add=$3
74    
75            # let container respond to kill -SIGPWR
76            inittab=$rootfs/etc/inittab
77            if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
78                    grep -v "$remove" ${inittab} > ${inittab}.new
79                    echo $add >> ${inittab}.new
80                    mv ${inittab}.new ${inittab}
81                    echo "$inittab modified with $add"
82            fi
83    }
84    
85    
86    lxc_log() {
87            echo `date +%Y-%m-%dT%H:%M:%S` $*
88    }
89    
90    
91    lxc_kill() {
92            name=$1
93            sig=$2
94    
95            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
96            if [ -z "$init_pid" ] ; then
97                    lxc-info -n $name
98                    exit 1
99            fi
100            lxc_log "$name kill $sig $init_pid"
101            /bin/kill $sig $init_pid
102    }
103    
104    lxc_stop() {
105            lxc_log "$name stop"
106            lxc_kill $name -SIGPWR
107            lxc-wait -n $name -s STOPPED
108            lxc_log "$name stoped"
109    #       rm -f /var/lib/lxc/${name}/on_boot
110    }
111    
112    
113    lxc_start() {
114            name=$1
115            rootfs=$(lxc_rootfs $1)
116    
117            if [ ! -e $rootfs ] ; then
118                    echo "ERROR $name rootfs $rootfs not found"
119                    return
120            fi
121    
122  # cleanup init scripts which don't work in containers          if ! lxc-info -n $name | grep RUNNING ; then
123  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}                  lxc_log "$name start"
124  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}                  lxc-start -n $name -o /tmp/${name}.log -d
125  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}                  lxc-wait  -n $name -s RUNNING
126                    lxc-info  -n $name
127                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
128            fi
129    }
130    
131  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
132    name=$1
133    rootfs=$(lxc_rootfs $1)
134    
135  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
136          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
137          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
138          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          test -z "$tasks" && exit 1
139            if [ "$tasks" -eq 1 ]; then
140    
141                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
142                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
143    
144                  case $runlevel in                  case $runlevel in
145                  N*)                  N*)
146                          # nothing for new boot state                          # nothing for new boot state
147                  ;;                  ;;
148                  ??0)                  ??0)
149                          echo "$name halt"                          lxc_log "$name halt"
150                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
151                            lxc-wait -n ${name} -s STOPPED
152                          break                          break
153                  ;;                  ;;
154                  ??6)                  ??6)
155                          echo "$name reboot";                          lxc_log "$name reboot";
156                          lxc-stop -n ${name}                          lxc-stop -n ${name}
157                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
158                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
159                  ;;                  ;;
160                  *)                  *)
# Line 54  while true; do Line 163  while true; do
163                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
164                  ;;                  ;;
165                  esac                  esac
166            else
167                    lxc_log "$name $tasks tasks"
168          fi          fi
169    
170            # time of 5 minutes on it JUST IN CASE...
171            inotifywait -qqt 300 ${vps_utmp}
172  done  done
173    
174    lxc_log "$name watchdog exited"
175    
176    }
177    
178    
179    usage() {
180            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
181            exit 3
182    }
183    
184    command_on_lxc() {
185    command=$1
186    shift
187    
188    echo "# $command $1"
189    
190    case "$command" in
191    
192    start)
193            lxc_exists $1
194            cleanup_init_scripts $1
195            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
196            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
197            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
198            lxc_start $1
199            # give container 5 seconds to start more than one process
200            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
201            ;;
202    stop|halt)
203            lxc_exists $1
204            lxc_stop $1
205            ;;
206    reload|force-reload|restart|reboot)
207            lxc_kill $1 -SIGINT
208            ;;
209    watchdog)
210            lxc_watchdog $1
211            ;;
212    boot)
213            echo $1 > /var/lib/lxc/$1/on_boot
214            ;;
215    disable)
216            echo -n > /var/lib/lxc/$1/on_boot
217            ;;
218    *)
219            usage
220            ;;
221    
222    esac
223    
224    }
225    
226    command=$1
227    test -z "$command" && usage
228    test "$command" = "status" && lxc_status && exit
229    shift
230    
231    if [ -z "$1" ] ; then
232            ls /var/lib/lxc/*/on_boot | while read path ; do
233                    name=`echo $path | cut -d/ -f5`
234                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
235                            command_on_lxc $command $name
236                    else
237                            echo "# skip $command $name"
238                    fi
239            done
240    else
241            while [ ! -z "$1" ] ; do
242                    command_on_lxc $command $1
243                    shift
244            done
245    fi
246    

Legend:
Removed from v.178  
changed lines
  Added in v.228

  ViewVC Help
Powered by ViewVC 1.1.26